function EditMovieAssistant(aMovieList, aMovieIndex)
{
   this.movieList = aMovieList;
   this.movieIndex = aMovieIndex;
    
   movieTitle = "";
   movieNotes = "";
   movieRating = 3;
   movieWhere = 0;
   movieDate = new Date();
   movieViewCount = 1;
   movieDirector = "";
   movieCast = "";
   movieGenre = "";
   movieOwned = 0;
   movieLocation = "";
    
   //  If an index is provided then this is an edit feed, not add feed
   //  so provide the existing title, url and modify the dialog title
   if (this.movieIndex >= 0)
   {
      this.dialogTitle = "Edit movie";
      var movie = this.movieList[this.movieIndex];
      movieTitle = movie.title;
      movieNotes = movie.notes;
      movieRating = movie.rating;
      movieWhere = movie.where;
      movieDate.setTime(movie.date);
      movieViewCount = movie.viewCount;
      movieDirector = movie.director;
      movieCast = movie.cast;
      movieGenre = movie.genre;
      movieOwned = movie.owned;
      movieLocation = movie.location;
   } 
   else
      this.dialogTitle = "Add movie";
}

EditMovieAssistant.prototype.setup = function()
{
   // setup application menu
   this.controller.setupWidget(Mojo.Menu.appMenu, ThisApp.AppMenuAttributes, ThisApp.AppMenuModel);
    
   // define "done" command menu
   this.commandMenuModel = {items: [{label:"Done", command:"do-Done"}]};
   this.controller.setupWidget(Mojo.Menu.commandMenu, undefined, this.commandMenuModel)
    
   // heading
   var addMovieTitleElement = this.controller.get("addMovieTitle");
   addMovieTitleElement.innerHTML = this.dialogTitle;
    
   // controls
   // --> title
   this.controller.setupWidget
         ("newMovieTitle",
	 {//hintText: "Title",
	  autoReplace: false,
	  textCase: Mojo.Widget.steModeTitleCase,
	  enterSubmits: false,
	  autoFocus: true},
	 this.titleModel = {value: movieTitle}
	);
   // --> "seen" section
   this.controller.setupWidget
	("newMovieWhere",
	 {label: "Format",
	  choices:
	    [{label: "Blu-Ray", value: 3},
             {label: "Cinema", value: 0},	     
	     {label: "DVD", value: 2},
             {label: "Netflix", value: 7},
             {label: "Online", value: 8},
             {label: "Other", value: 9},
	     {label: "TV", value: 1},
             {label: "VHS", value: 4},
	     {label: "Video file", value: 5},
             {label: "YouTube", value: 6}]},
	 this.whereModel = {value: movieWhere}
	);
   this.controller.setupWidget
	("newMovieWhen",
	 {label: "Date",
          labelPlacement: Mojo.Widget.labelPlacementRight},
	 this.dateModel = {date: movieDate}
	);
   this.controller.setupWidget
	("newMovieViewCount",
	 {label: "Number of times",
          labelPlacement: Mojo.Widget.labelPlacementRight,
	  min: 0,
	  max: 150},
	 this.viewCountModel = {value: movieViewCount}
	);	
   this.controller.setupWidget
	("newMovieRating",
	 {label: "Rating",
          labelPlacement: Mojo.Widget.labelPlacementRight,
	  modelProperty: "value",
	  min: 0,
	  max: 5},
	  this.ratingModel = {value: movieRating}
	);
   // --> owned section
   this.controller.setupWidget
	("newMovieOwned",
	 {label: "Format",
	  choices:
	    [{label: "Don't own it", value: 0},
	     {label: "Blu-Ray", value: 2},
	     {label: "DVD", value: 1},
             {label: "VHS", value: 3},
	     {label: "Video file", value: 4}]},
	 this.ownedModel = {value: movieOwned}
	);
   this.controller.setupWidget
	("newMovieLocation",
	 {hintText: "Location",
	  autoReplace: false,
	  textCase: Mojo.Widget.steModeTitleCase,
	  enterSubmits: false},
	 this.locationModel = {value: movieLocation}
	);         
   // --> info section
   this.controller.setupWidget
	("movieDirector",
	 {hintText: "Director",
	  autoReplace: false,
	  textCase: Mojo.Widget.steModeTitleCase,
	  enterSubmits: false},
	 this.directorModel = {value: movieDirector}
	);
   this.controller.setupWidget
	("movieCast",
	 {hintText: "Cast",
	  autoReplace: false,
	  textCase: Mojo.Widget.steModeTitleCase,
	  enterSubmits: false},
	 this.castModel = {value: movieCast}
	);
   this.controller.setupWidget
	("movieGenre",
	 {hintText: "Genre",
	  autoReplace: false,
	  textCase: Mojo.Widget.steModeTitleCase,
	  enterSubmits: false},
	 this.genreModel = {value: movieGenre}
	);
   // --> notes
   this.controller.setupWidget
	("newMovieNotes",
	 {autoReplace: false,
	  textCase: Mojo.Widget.steModeSentenceCase,
	  multiline: true,
	  limitResize: true,
	  enterSubmits: false},
	 this.notesModel = {value: movieNotes}
	);
}

EditMovieAssistant.prototype.activate = function(event)
{
}


EditMovieAssistant.prototype.deactivate = function(event)
{
}

EditMovieAssistant.prototype.cleanup = function(event)
{
   Mojo.Log.info("--> edit scene cleanup")
   
   if (this.movieIndex >= 0)
   {
      var movie = this.movieList[this.movieIndex];
      movie.title = this.titleModel.value;
      movie.notes = this.notesModel.value;
      movie.rating = this.ratingModel.value;
      movie.where = this.whereModel.value;
      movie.date = this.dateModel.date.getTime();
      movie.viewCount = this.viewCountModel.value;
      movie.director = this.directorModel.value;
      movie.cast = this.castModel.value;
      movie.genre = this.genreModel.value;
      movie.owned = this.ownedModel.value;
      movie.location = this.locationModel.value;
   }
   else if (this.titleModel.value != "")
   {
      this.movieList.push(
         {title: this.titleModel.value,
          notes: this.notesModel.value,
          rating: this.ratingModel.value,
          where: this.whereModel.value,
          date: this.dateModel.date.getTime(),
          viewCount: this.viewCountModel.value,
          director: this.directorModel.value,
          cast: this.castModel.value,
          genre: this.genreModel.value,
          owned: this.ownedModel.value,
          location: this.locationModel.value});
   }
   
   ThisApp.movies.sortList(this.movieList);
   ThisApp.movies.storeInDb();		
   ThisApp.moviesChanged = true;   
}

EditMovieAssistant.prototype.handleCommand = function(event)
{
    if (event.type == Mojo.Event.command)
    {
        switch(event.command)
        {
            case "do-Done":
                /*
		if (this.movieIndex >= 0)
		{
		    var movie = this.movieList[this.movieIndex];
		    movie.title = this.titleModel.value;
		    movie.notes = this.notesModel.value;
		    movie.rating = this.ratingModel.value;
		    movie.where = this.whereModel.value;
		    movie.date = this.dateModel.date.getTime();
		    movie.viewCount = this.viewCountModel.value;
                    movie.director = this.directorModel.value;
                    movie.cast = this.castModel.value;
                    movie.genre = this.genreModel.value;
		    movie.owned = this.ownedModel.value;
                    movie.location = this.locationModel.value;
		}
		else if (this.titleModel.value != "")
		{
		    this.movieList.push(
			{title: this.titleModel.value,
			 notes: this.notesModel.value,
			 rating: this.ratingModel.value,
			 where: this.whereModel.value,
			 date: this.dateModel.date.getTime(),
			 viewCount: this.viewCountModel.value,
                         director: this.directorModel.value,
                         cast: this.castModel.value,
                         genre: this.genreModel.value,
			 owned: this.ownedModel.value,
                         location: this.locationModel.value});
		}*/
                if (this.titleModel.value != "")
                {
                    this.controller.stageController.popScene();
                    break;
                }                
		else
		{
		    Mojo.Controller.errorDialog("Please enter at least the title of the movie.")
		    break;		    
		}		
		
                /*
                ThisApp.movies.sortList(this.movieList);
		ThisApp.movies.storeInDb();		
		ThisApp.moviesChanged = true;
		
                this.controller.stageController.popScene();
                break;
                */                
        }
    }

    if (event.type == Mojo.Event.commandEnable)
    {
        if (event.command == ThisApp.MenuFilterCommand)
            event.preventDefault();
    }    
}