// search comparison functions
var movieHasString = function(query, movie)
{
    if (movie.title.toUpperCase().indexOf(query) >= 0)
	return true;	
    return false;
};

// filter function
var isFilteredItem = function(movie)
{
    if (ThisApp.preferences.filters.length == 0)
	return true;
    
    result = false;
    for (var i = 0; i < ThisApp.preferences.filters.length; i++)
    {
	breaknow = false;
	isgood = false;
	
	// get movie field value
	filter = ThisApp.preferences.filters[i];
	var ftext = "";
	if (filter.field == 0)
	    ftext = movie.title;
	else if (filter.field == 1)
	{
	    if (movie.where == 0)	ftext = "cinema";
	    else if (movie.where == 1)	ftext = "tv";
	    else if (movie.where == 2)	ftext = "dvd";
	    else if (movie.where == 3)	ftext = "blu-ray";
	    else if (movie.where == 4)	ftext = "vhs";
	    else if (movie.where == 5)	ftext = "file";
	    else if (movie.where == 6)	ftext = "youtube";
	    else if (movie.where == 7)	ftext = "netflix";
	    else if (movie.where == 8)	ftext = "online";
	    else
		ftext = "other";
	}
	else if (filter.field == 2)
	{
	    d = new Date();
	    d.setTime(movie.date);
	    ftext = d.getFullYear()+'';
	}
	else if (filter.field == 3)
	{
	    d = new Date();
	    d.setTime(movie.date);
	    ftext = Mojo.Format.formatDate(d, {date: 'long'}); //d.toDateString();
	}
	else if (filter.field == 4)
		ftext = movie.viewCount+'';
	else if (filter.field == 5)
		ftext = movie.rating+'';
	else if (filter.field == 6)
	{
	    ftext = "don't own it";
	    if (movie.owned == 1)	ftext = "dvd";
	    else if (movie.owned == 2)	ftext = "blu-ray";
	    else if (movie.owned == 3)	ftext = "vhs";
	    else if (movie.owned == 4)	ftext = "video file";
	}
	else if (filter.field == 7)
	    ftext = movie.location;
	else if (filter.field == 8)
	    ftext = movie.director;
	else if (filter.field == 9)
	    ftext = movie.cast;
	else if (filter.field == 10)
	    ftext = movie.genre;
	else if (filter.field == 11)
	    ftext = movie.notes;
	
	if (ftext == "")
	{
	    isgood = false;
	    break;
	}
	    
	ftext = ftext.toLowerCase();
	
	//Mojo.log("isFilteredItem - equals=" + filter.equals + " ftext=" + ftext + " s=" + filter.text);

	// process filter text	
	var s = filter.text.toLowerCase();
	if (filter.equals == 0)
	    isgood = (s == ftext);
	else if (filter.equals == 1)
	    isgood = (s != ftext);
	else if (filter.equals == 2)
	{
	    var idx = ftext.search(s);
	    isgood = (idx != -1);
	}
	else if (filter.equals == 3)
	{
	    var idx = ftext.search(s);
	    isgood = (idx == -1);
	}
	else if (filter.equals == 4)
	    isgood = (s > ftext);
	else if (filter.equals == 5)
	    isgood = (s < ftext);
	    
	// check against and/or
	if (ThisApp.preferences.filterCombine == 0)	// and
	{
	    result = isgood;
	    breaknow = !isgood;
	}
	else 						// or
	{
	    result = isgood;
	    breaknow = isgood;
	}
	
	if (breaknow)
	    break;
    }
    
    return result;
};



// --- MAINASSISTANT ---

function MainAssistant()
{
};

MainAssistant.prototype.setup = function()
{
    ThisApp.mainScene = this;
    
    this.EmptyListText = "<center><br>You haven't added any movies.<br>Click the + button to do so now.</center>";
    
    // setup application menu
    this.controller.setupWidget(Mojo.Menu.appMenu, ThisApp.AppMenuAttributes, ThisApp.AppMenuModel);
    
    // define "add" command menu
    this.mainCommandMenuModel =
	{items:
	    [{icon: "new", command:"do-NewItem"},
	     {items: []},
	     {items: []}
	     //{label: "Random", command: "do-Random"}
	     ]
	};
    
    // add command menu
    this.controller.setupWidget(Mojo.Menu.commandMenu, undefined, this.mainCommandMenuModel)
	
    // setup spinner
    this.spinnerLAttrs = {
	spinnerSize: 'large'
    }
    this.spinnerModel = {
	spinning: true
    }
    this.controller.setupWidget('spinner', this.spinnerLAttrs, this.spinnerModel);
    
    // setup list
    this.listAttributes =
	{
	    itemTemplate: "main/movieRowTemplate",
	    listTemplate: "main/movieListTemplate",
	    swipeToDelete: true,
	    renderLimit: 40,
	    reorderable: false,
	    dividerFunction: this.dividerAlpha.bind(this),
	    filterFunction: this.searchList.bind(this),
	    formatters:{rating: this.formatRating.bind(this)}
	};
    this.controller.setupWidget
	("movieListWgt",
	 this.listAttributes,
	 this.listModel = {items: ThisApp.movies.list}
	);
	
    // set list event handlers
    // --> click item
    this.clickMovieHandler = this.clickMovie.bindAsEventListener(this);
    this.controller.listen("movieListWgt", Mojo.Event.listTap, this.clickMovieHandler);
    // --> delete item
    this.deleteMovieHandler = this.deleteMovie.bindAsEventListener(this);
    this.controller.listen("movieListWgt", Mojo.Event.listDelete, this.deleteMovieHandler);
    // --> filter
    this.searchListHandler = this.searchList.bindAsEventListener(this);
    this.controller.listen("movieListWgt", Mojo.Event.filter, this.searchListHandler, true);
    
    // other event handlers
    // --> shake end
    this.controller.listen(document, 'shakeend', this.handleShakeEnd.bindAsEventListener(this));
    
    // load movie db
    ThisApp.movies.loadFromDb();    
};

MainAssistant.prototype.activate = function(event)
{
    if (this.controller.stageController.setWindowOrientation)
        this.controller.stageController.setWindowOrientation("free");
    
    this.updateListControl();
};

MainAssistant.prototype.deactivate = function(event)
{
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
};

MainAssistant.prototype.cleanup = function(event)
{
    this.controller.stopListening("movieListWgt", Mojo.Event.listTap, this.clickMovieHandler);
    this.controller.stopListening("movieListWgt", Mojo.Event.listDelete, this.deleteMovieHandler);
    this.controller.stopListening("movieListWgt", Mojo.Event.filter, this.searchListHandler);
    // just in case
    ThisApp.movies.storeInDb();
};

MainAssistant.prototype.handleCommand = function(event)
{
    if (event.type == Mojo.Event.command)
    {
        switch(event.command)
        {
            case "do-NewItem":
		Mojo.Controller.stageController.pushScene("edit-movie", ThisApp.movies.list, -1);
                break;
	    case "do-Random":
		this.showRandomMovie();
		break;
	    case "do-filtered":
		ThisApp.filterSwitch = !ThisApp.filterSwitch;
		ThisApp.filterChanged = true;
		this.updateListControl();
		break;
	    case "do-showFilterDialog":
		Mojo.Controller.stageController.pushScene("filter");
		break;
        }
    }
};

MainAssistant.prototype.clickMovie = function(event)
{
    Mojo.Controller.stageController.pushScene("show-movie", this.entireList, event.index);
};

MainAssistant.prototype.deleteMovie = function(event)
{
    // delete from movie list
    var index = ThisApp.movies.list.indexOf(event.item);
    if (index >= 0)
	ThisApp.movies.list.splice(index, 1);
    // delete from filtered list
    this.entireList.splice(event.index, 1);
    
    // save now
    ThisApp.movies.storeInDb();
    
    if (ThisApp.movies.list.length == 0)
	this.controller.get("hintText").innerHTML = this.EmptyListText;
	
    this.updateListControl();
};

MainAssistant.prototype.dividerAlpha = function(itemModel)
{
    var s = itemModel.title.toString();
    var c;
    if (s.search(/the /i) == 0 && s.length > 4)
	c = s[4];
    else
	c = s[0];

    if (c[0] >= '0' && c[0] <= '9')
	return '#';
    else
	return c;
};

MainAssistant.prototype.searchList = function(filterString, widget, offset, limit)
{
    var subset = [];
    var totalSubsetSize = 0;
    
    this.filter = filterString;
    
    // if empty string, return empty subset, otherwise search
    var items = [];
	
    // search loop
    s = filterString.toUpperCase();
    for (var i = 0; i < ThisApp.movies.list.length; i++)
    {
        var movie = ThisApp.movies.list[i];
	// --> filter
	if (ThisApp.filterSwitch == true)
	{
	    if (!isFilteredItem(movie))
		continue;
	}
	// --> search
        if (filterString == "")
	    items.push(movie);
        else if (movieHasString(s, movie))
	    items.push(movie);
    }
	
    this.entireList = items;
    ThisApp.movies.sortList(this.entireList);
	
    var cursor = 0;
    while (true)
    {
        if (cursor >= this.entireList.length)
    	break;
        
        if (subset.length < limit && totalSubsetSize >= offset)
    	subset.push(this.entireList[cursor]);
    	
        totalSubsetSize++;
        cursor++;
    }
    
    // update list
    widget.mojo.noticeUpdatedItems(offset, subset);
    // update filter field count of items found
    widget.mojo.setLength(totalSubsetSize);
    widget.mojo.setCount(totalSubsetSize);
};

MainAssistant.prototype.updateListControl = function()
{
    if (ThisApp.moviesChanged || ThisApp.filterChanged)
    {
        this.listModel.items = ThisApp.movies.list; 
        this.controller.modelChanged(this.listModel, this);
	ThisApp.moviesChanged = false;
	ThisApp.filterChanged = false;
    }
    
    this.mainCommandMenuModel.items[1].items = [];
    if (ThisApp.preferences.filters.length > 0 && ThisApp.movies.list.length > 0)
    {
	if (ThisApp.filterSwitch)
	    this.mainCommandMenuModel.items[1].items.push({label: "Filtered", command: "do-filtered"});
	else
	    this.mainCommandMenuModel.items[1].items.push({label: "Apply Filter", command: "do-filtered"});
	//this.mainCommandMenuModel.items[1].items.push({label: "...", command: "do-showFilterDialog"});	// nice to have, but the menu is still available
    }
    this.mainCommandMenuModel.items[2].items = [];
    if (ThisApp.movies.list.length > 0)
	this.mainCommandMenuModel.items[2].items.push({label: "Random", command: "do-Random"});
    this.controller.modelChanged(this.mainCommandMenuModel, undefined);
    
    if (ThisApp.movies.list.length != 0)
	this.controller.get("hintText").innerHTML = "";    
}

MainAssistant.prototype.considerForNotification = function(params)
{
    if (params)
    {
	if (params.id == "listChanged")
	{
	    ThisApp.moviesChanged = true;
	    this.updateListControl();
	}
	if (params.id == "filtersChanged")
	{
	    ThisApp.filtersChanged = true;
	    this.updateListControl();
	}
	if (params.id == "listLoaded")
	{
	    this.spinnerModel.spinning = false;
	    this.controller.modelChanged(this.spinnerModel);
	    if (ThisApp.movies.list.length == 0)
		this.controller.get("hintText").innerHTML = this.EmptyListText;
	}	
    }
    
    // make sure the chain continues
    return params;
};

MainAssistant.prototype.formatRating = function(n, model)
{
    s = "";
    for (var i = 0; i < 5; i++)
    {
	if (i < model.rating)
	    s = s + '<img src="images/star_yellow_small.png"></img>';
	else
	    s = s + '<img src="images/star_empty_small.png"></img>';
    }
    return s;
}

MainAssistant.prototype.handleShakeEnd = function(event)
{
    if (this.stageController.activeScene() == this)
	this.showRandomMovie();
}

MainAssistant.prototype.showRandomMovie = function()
{
    // get random index
    now = new Date();	// use seconds as seed for random
    seed = now.getSeconds();
    var random_number = Math.random(seed)/*/seed*/;
    var idx = Math.floor(random_number*ThisApp.movies.list.length);
    
    // find first movie that qualifies
    var originalidx = idx;
    while (true)
    {
	movie = ThisApp.movies.list[idx];
	nogood = false;
	
	// check owned status
	if (!nogood && ThisApp.preferences.randomOwnedOnly)
	{
	    if (movie.owned == undefined)
	        movie.owned = 0;	
	    if (movie.owned == 0)
		nogood = true;
	}
	
	// check if it's in the list of last x movies that were selected
	if (!nogood && ThisApp.preferences.randomIgnoreLast > 0)
	{	    
	    var count = ThisApp.preferences.randomLastSelected.length;
	    if (count > ThisApp.preferences.randomIgnoreLast)
		count = ThisApp.preferences.randomIgnoreLast;
	    for (var x = 0; x < count; x++)
	    {
		var s = ThisApp.preferences.randomLastSelected[x];
		if (s == movie.title)
		{
		    nogood = true;
		    break;
		}
	    }
	}
	
	// if this one is ok, use it	
	if (!nogood)
	    break;

	// next one
	idx++;
	if (idx >= ThisApp.movies.list.length)
	    idx = 0;
	if (idx == originalidx)
	{
	    idx = -1;
	    break;
	}
    }    

    // show the movie we found (if any)
    if (idx >= 0)
    {
	// --> add to start of list
	ThisApp.preferences.randomLastSelected.unshift(movie.title);
	// --> remove end of list
	while (ThisApp.preferences.randomLastSelected.length > ThisApp.preferences.randomIgnoreLast)
	    ThisApp.preferences.randomLastSelected.splice(ThisApp.preferences.randomLastSelected.length-1);
	// --> show movie's scene
	this.controller.stageController.pushScene("show-movie", this.entireList, idx);
    }
    else
    {
        this.controller.showAlertDialog(
	    {title: ("Random"),
	     message: ("No movie was found"),
	     choices:[{label: ("OK"), value:"", type:'dismiss'}]});
    }
}