function PreferencesAssistant()
{
	/* this is the creator function for your scene assistant object. It will be passed all the 
	   additional parameters (after the scene name) that were passed to pushScene. The reference
	   to the scene controller (this.controller) has not be established yet, so any initialization
	   that needs the scene controller should be done in the setup function below. */
}

PreferencesAssistant.prototype.setup = function()
{
    // RANDOM
    // --> only owned
    this.controller.setupWidget("randomOwnedWgt",
        this.attributes =
            {trueValue: true,
             falseValue: false},
        this.randomOwnedOnlyModel =
            {value: ThisApp.preferences.randomOwnedOnly,
             disabled: false}
        );
    // --> ignore last    
    this.controller.setupWidget("randomIgnoreLastWgt",
        this.attributes =
            {trueValue: 5,
             falseValue: 1},
        this.randomIgnoreLastModel =
            {value: ThisApp.preferences.randomIgnoreLast,
             disabled: false}
        );    
}

PreferencesAssistant.prototype.activate = function(event)
{
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
}


PreferencesAssistant.prototype.deactivate = function(event)
{
    ThisApp.preferences.randomOwnedOnly = this.randomOwnedOnlyModel.value;
    ThisApp.preferences.randomIgnoreLast = this.randomIgnoreLastModel.value;
}

PreferencesAssistant.prototype.cleanup = function(event)
{
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
}
