//----------------------
//  GLOBALS
//----------------------

// ThisApp namespace
ThisApp = {};

ThisApp.versionString = "1.1.3";

// application menu
ThisApp.MenuPreferencesCommand  = 'do-preferences';
ThisApp.MenuFilterCommand       = 'do-Filter';
ThisApp.AppMenuAttributes = {omitDefaultItems: true};            
ThisApp.AppMenuModel =
    {
        visible: true,
        items:
            [Mojo.Menu.editItem,
             {label: "About...", command: 'do-aboutThisApp'},
             {label: "Filter...", command: ThisApp.MenuFilterCommand, checkEnabled: true},
             {label: "Preferences...", command: ThisApp.MenuPreferencesCommand, checkEnabled: true}
             //Mojo.Menu.helpItem
            ]
    };
    
// some variables
ThisApp.filterSwitch = false;
ThisApp.moviesChanged = false;
ThisApp.filterChanged = false;



//----------------------
//  STAGE ASSISTANT
//----------------------

function StageAssistant()
{
}

StageAssistant.prototype.setup = function()
{    
    // create the movie list object
    ThisApp.movies = new movieList();    
    
    // preferences
    ThisApp.preferences = new Preferences();
    ThisApp.preferences.loadFromCookie();
    ThisApp.preferences.loadFilterList();
    
    // push our first scene
    this.controller.pushScene("main");
}

StageAssistant.prototype.cleanup = function(event)
{    
    ThisApp.movies.storeInDb();
    ThisApp.preferences.saveToCookie();
    ThisApp.preferences.saveFilterList();
}

StageAssistant.prototype.handleCommand = function(event)
{
    var currentScene = this.controller.activeScene();    
    
    if (event.type == Mojo.Event.command)
    {
        switch(event.command)
        {
            case "do-aboutThisApp":
                currentScene.showAlertDialog
                    ({
                        onChoose: function(value) {},
                        title: "Movie Diary - v#{version}".interpolate({version: ThisApp.versionString}),
                        message: "Copyright (c) 2009 by Frederic Vanmol",
                        choices: [{label:"OK", value:""}]
                    });
                break;
            
            case 'do-preferences':
                this.controller.pushScene("preferences");
                break;
                
            case 'do-Filter':
                this.controller.pushScene("filter");
                break;
        }
    }
}