/*

    some list data while it's not dynamic yet
    
    movie list item properties...
    - title (string)
    - notes (string)
    - rating (int)
    - where (int)   --> 0=cinema 1=tv 2=dvd 3=blu-ray 4=vhs 5=file 6=youtube 7=netflix 8=online 9=other
    - viewCount (int)
    - date (date)
    - director (string)
    - cast (string)
    - genre (string)
    - owned (int)   --> 0=not 1=dvd 2=blu-ray 3=vhs 4=file
    - location (string)

*/

function compareMovies(a, b)
{
    var sA = a.title.toString();
    var idx = sA.search(/the /i);
    if (idx == 0 && sA.length > 4)
        sA = sA.slice(idx+4);
        
    var sB = b.title.toString();
    idx = sB.search(/the /i);
    if (idx == 0 && sB.length > 4)
        sB = sB.slice(idx+4);
    
   if (sA < sB)
   {
      return -1;
   }
   else if (sA > sB)
   {
      return 1;
   }
   else
   {
      return 0;
   }
}

var movieList = Class.create
({
    initialize: function()
    {
        this.list = [];
    },
    
    loadFromDb: function()
    {
        this.db = new Mojo.Depot
            ({name: "ext:movieDiaryDb", version: 1, estimatedSize: 100000, replace: false},
             this.loadFromDbOpenOk.bind(this),
             this.loadFromDbOpenFail.bind(this)
            );
    },
    
    loadFromDbOpenOk: function()
    {
        this.db.get("movieList", this.loadMovieDbGetSuccess.bind(this), this.loadMovieDbFailed.bind(this));
    },
    
    loadFromDbOpenFail: function(result)
    {
        Mojo.Log.warn("Can't open ext movie database");
    },
    
    loadMovieDbGetSuccess: function(loaded_list)
    {
        if (loaded_list == null)
            Mojo.Log.warn("loaded_list was null.");
        else
        {
            Mojo.Log.info("List was loaded succesfully.");
            this.list = loaded_list;
            
            ThisApp.moviesChanged = true;
            Mojo.Controller.getAppController().sendToNotificationChain({id: "listChanged"});
        }
        
        Mojo.Controller.getAppController().sendToNotificationChain({id: "listLoaded"});        
    },
    
    loadMovieDbFailed: function()
    {
        Mojo.Log.warn("failed to load item from db.");
    },    
    
    storeInDb: function()
    {
        Mojo.Log.info("storeInDb() called.");
        this.db.add("movieList", this.list, function(){Mojo.Log.info("list saved");}, function(){Mojo.Log.info("list NOT saved");});
        ThisApp.moviesChanged = false;
    },
    
    sortList: function(list)
    {
        list.sort(compareMovies);
    }
});